> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gmicloud.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Register an organization

> Allow users to register an organization. The user will automatically leave their current organization.



## OpenAPI

````yaml /api-spec/ias-public-api.yaml post /organizations
openapi: 3.0.3
info:
  title: IAM Service API
  description: APIs for IAM Service.
  version: 2.4.0
servers:
  - url: https://console.gmicloud.ai/api/v1
    description: IAM Service API
security: []
paths:
  /organizations:
    post:
      tags:
        - organizations
      summary: Register an organization
      description: >-
        Allow users to register an organization. The user will automatically
        leave their current organization.
      operationId: registerOrganization
      requestBody:
        description: The organization registration request body.
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/registerOrganizationRequest'
      responses:
        '201':
          description: Successfully registered the organization.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/registerOrganizationResponse'
        '400':
          description: >
            - [group:**request**, code:**0**]: Invalid field in the request
            body.

            - [group:**request**, code:**1**]: The request body is required.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrStatusMsg'
              examples:
                Invalid field in the request body:
                  summary: Invalid field in the request body.
                  value:
                    group: request
                    code: 0
                    validationDetail:
                      - field: name
                        expression: required
                        originalValue: ''
                        reason: This field is required.
                No request body:
                  summary: No request body.
                  value:
                    group: request
                    code: 1
                    message: The request body is required.
        '409':
          description: >
            - [group:**organization**, code:**0**]: User already owns an
            organization.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrStatusMsg'
              examples:
                User already owns an organization:
                  summary: The user already owns an organization.
                  value:
                    group: organization
                    code: 0
                    message: User already owns an organization.
        '500':
          description: >
            - [group:**organization**, code:**1000**]: Create organization
            encountered DB error.

            - [group:**organization**, code:**1001**]: Create organization
            grouping policy encountered error.

            - [group:**organization**, code:**1600**]: Delete organization
            grouping policy encountered error.

            - [group:**session**, code:**3**]: Failed to save session to cache.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrStatusMsg'
              examples:
                Create organization encountered DB error:
                  summary: Create organization encountered DB error.
                  value:
                    group: organization
                    code: 1000
                    message: Create organization encountered DB error.
                    traces:
                      - DB error occurred.
      security:
        - bearerAuth: []
components:
  schemas:
    registerOrganizationRequest:
      type: object
      x-go-name: registerOrganizationRequest
      properties:
        name:
          type: string
          description: The organization's name.
          example: My Organization
          x-oapi-codegen-extra-tags:
            binding: required
      required:
        - name
    registerOrganizationResponse:
      type: object
      x-go-name: registerOrganizationResponse
      properties:
        id:
          type: string
          format: uuid
          x-go-type: uuid.UUID
          description: The organization's ID.
          example: a0eebc99-9c0b-4ef8-bb6d-6bb9bd380a11
      required:
        - id
    ErrStatusMsg:
      type: object
      properties:
        group:
          type: string
          description: >-
            API function group\n -Will be "request" if there are invalid request
            parameters.
          x-oapi-codegen-extra-tags:
            binding: required
        code:
          type: integer
          description: The substatus error code for the API response.
          x-oapi-codegen-extra-tags:
            binding: required
        message:
          type: string
          description: The substatus error Message for API response.
          x-go-type-skip-optional-pointer: true
        traces:
          type: array
          items:
            type: string
          description: The original error messages.
          x-go-type-skip-optional-pointer: true
        validationDetail:
          type: array
          items:
            $ref: '#/components/schemas/ValidationDetail'
          description: >-
            Returned when there are invalid request
            paremeters(group="request")\n List of invalid fields and the reason
            of error.
          x-go-type-skip-optional-pointer: true
      example:
        group: request
        code: 0
        validationDetail:
          - field: email
            expression: required
            originalValue: ''
            reason: This field is required.
      required:
        - group
        - code
    ValidationDetail:
      type: object
      properties:
        field:
          type: string
          description: The field of the request data.
          x-go-type-skip-optional-pointer: true
        expression:
          type: string
          description: The form of violation.
          x-go-type-skip-optional-pointer: true
        argument:
          type: string
          description: The number or data to support the expression.
          x-go-type-skip-optional-pointer: true
        originalValue:
          description: The original value from the request.
          x-go-type-skip-optional-pointer: true
        reason:
          type: string
          description: The reason for the validation error.
          x-go-type-skip-optional-pointer: true
      example:
        - field: fieldXXX
          expression: required
          originalValue: ''
          reason: This field is required.
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >
        An access token used to authenticate a user and grant access to
        restricted APIs. It is issued by session APIs.

        For status codes related to this header, refer to the 

        [Common Headers
        Documentation](https://gmicloud.atlassian.net/wiki/spaces/CE/pages/47199534/Common+Headers#Authorization).

````